# TODO: review configure options:
# - BATTERY_STATUS (BR: upower-devel)
# - FTL_JIT on !x86_64?
# - MEDIA_STREAM (BR: openwebrtc)
#
# Conditional build:
%bcond_without	gtk2		# WebKitPluginProcess2 to load GTK+ 2.x based plugins
%bcond_without	introspection	# disable introspection
%bcond_with	cairogl		# accelerated 2D canvas using cairo-gl
%bcond_with	seccomp		# seccomp filters (broken as of 2.6.5)
%bcond_without	wayland		# Wayland target (requires GTK+ wayland target)
#
# it's not possible to build this with debuginfo on 32bit archs due to
# memory constraints during linking
%ifarch %{ix86} x32
%define		_enable_debug_packages		0
%endif
Summary:	Port of WebKit embeddable web component to GTK+ 3
Summary(pl.UTF-8):	Port osadzalnego komponentu WWW WebKit do GTK+ 3
Name:		gtk-webkit4
Version:	2.18.5
Release:	1
License:	BSD-like
Group:		X11/Libraries
Source0:	https://webkitgtk.org/releases/webkitgtk-%{version}.tar.xz
# Source0-md5:	af18c2cfa00cadfd0b4d8db21cab011d
Patch0:		x32.patch
Patch1:		%{name}-icu59.patch
URL:		https://webkitgtk.org/
BuildRequires:	/usr/bin/ld.gold
BuildRequires:	EGL-devel
BuildRequires:	OpenGL-GLX-devel
BuildRequires:	OpenGLESv2-devel
BuildRequires:	at-spi2-core-devel >= 2.6.0
BuildRequires:	atk-devel
BuildRequires:	bison >= 2.3
BuildRequires:	cairo-devel >= 1.10.2
BuildRequires:	cmake >= 2.8.12
BuildRequires:	docbook-dtd412-xml
BuildRequires:	enchant-devel >= 0.22
BuildRequires:	flex >= 2.5.34
BuildRequires:	fontconfig-devel >= 2.8.0
BuildRequires:	freetype-devel >= 1:2.4.2
BuildRequires:	gcc-c++ >= 6:4.9
BuildRequires:	geoclue2-devel >= 2.1.5
BuildRequires:	gettext-devel
BuildRequires:	glib2-devel >= 1:2.36.0
BuildRequires:	glibc-misc
%{?with_introspection:BuildRequires:	gobject-introspection-devel >= 1.32.0}
BuildRequires:	gperf >= 3.0.1
BuildRequires:	gstreamer-devel >= 1.2.3
BuildRequires:	gstreamer-plugins-bad-devel >= 1.6.0
BuildRequires:	gstreamer-plugins-base-devel >= 1.2.3
%{?with_gtk2:BuildRequires:	gtk+2-devel >= 2:2.24.10}
BuildRequires:	gtk+3-devel >= 3.12.0
BuildRequires:	gtk-doc >= 1.10
BuildRequires:	harfbuzz-devel >= 0.9.7
BuildRequires:	harfbuzz-icu-devel >= 0.9.7
BuildRequires:	hyphen-devel
BuildRequires:	libicu-devel >= 59
BuildRequires:	libjpeg-devel
BuildRequires:	libnotify-devel
BuildRequires:	libpng-devel
BuildRequires:	libsecret-devel
BuildRequires:	libsoup-devel >= 2.42.0
BuildRequires:	libstdc++-devel >= 6:4.9
BuildRequires:	libwebp-devel
BuildRequires:	libxml2-devel >= 1:2.8.0
BuildRequires:	libxslt-devel >= 1.1.7
BuildRequires:	pango-devel >= 1:1.32.0
BuildRequires:	perl-base >= 1:5.10.0
BuildRequires:	pkgconfig
%if %{with cairogl}
BuildRequires:	pkgconfig(cairo-egl)
BuildRequires:	pkgconfig(cairo-gl)
BuildRequires:	pkgconfig(cairo-glx)
%endif
BuildRequires:	python >= 1:2.7.0
BuildRequires:	rpmbuild(macros) >= 1.699
BuildRequires:	ruby >= 1:1.9
BuildRequires:	ruby-modules >= 1:1.9
BuildRequires:	sqlite3-devel >= 3
BuildRequires:	tar >= 1:1.22
BuildRequires:	xorg-lib-libXcomposite-devel
BuildRequires:	xorg-lib-libXdamage-devel
BuildRequires:	xorg-lib-libXrender-devel
BuildRequires:	xorg-lib-libXt-devel
BuildRequires:	xz
BuildRequires:	zlib-devel
Requires:	cairo >= 1.10.2
Requires:	enchant >= 0.22
Requires:	fontconfig-libs >= 2.8.0
Requires:	freetype >= 1:2.4.2
Requires:	glib2 >= 1:2.36.0
Requires:	gstreamer >= 1.2.3
Requires:	gstreamer-plugins-base >= 1.2.3
%{?with_gtk2:Requires:	gtk+2 >= 2:2.24.10}
Requires:	gtk+3 >= 3.12.0
Requires:	harfbuzz >= 0.9.7
Requires:	libsoup >= 2.42.0
Requires:	libxml2 >= 1:2.8.0
Requires:	libxslt >= 1.1.7
Requires:	pango >= 1:1.32.0
%{?with_introspection:Conflicts:	gir-repository < 0.6.5-7}
# Source/JavaScriptCore/CMakeLists.txt /WTF_CPU_
ExclusiveArch:	%{ix86} %{x8664} x32 %{arm} aarch64 hppa mips ppc ppc64 ppc64le s390 s390x sh4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# __once_call, __once_called non-function symbols from libstdc++
%define		skip_post_check_so	lib.*gtk-4.0.*

%description
gtk-webkit4 is a port of the WebKit embeddable web component to GTK+
3.

%description -l pl.UTF-8
gtk-webkit4 to port osadzalnego komponentu WWW WebKit do GTK+ 3.

%package devel
Summary:	Development files for WebKit for GTK+ 3
Summary(pl.UTF-8):	Pliki programistyczne komponentu WebKit dla GTK+ 3
Group:		X11/Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	glib2-devel >= 1:2.36.0
Requires:	gtk+3-devel >= 3.12.0
Requires:	libsoup-devel >= 2.42.0
Requires:	libstdc++-devel >= 6:4.9

%description devel
Development files for WebKit for GTK+ 3.

%description devel -l pl.UTF-8
Pliki programistyczne komponentu WebKit dla GTK+ 3.

%package apidocs
Summary:	WebKit API documentation
Summary(pl.UTF-8):	Dokumentacja API WebKita
Group:		Documentation
Requires:	gtk-doc-common
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description apidocs
WebKit API documentation.

%description apidocs -l pl.UTF-8
Dokumentacja API WebKita.

%prep
%setup -q -n webkitgtk-%{version}
%patch0 -p1
%patch1 -p1

%build
install -d build
cd build
%cmake .. \
	%{?with_cairogl:-DENABLE_ACCELERATED_2D_CANVAS=ON} \
	-DENABLE_CREDENTIAL_STORAGE=ON \
	-DENABLE_GEOLOCATION=ON \
	-DENABLE_GTKDOC=ON \
	%{!?with_introspection:-DENABLE_INTROSPECTION=OFF} \
	%{!?with_gtk2:-DENABLE_PLUGIN_PROCESS_GTK2=OFF} \
	%{?with_seccomp:-DENABLE_SECCOMP_FILTERS=ON} \
	%{!?with_wayland:-DENABLE_WAYLAND_TARGET=OFF} \
%ifarch x32
	-DENABLE_JIT=OFF \
%endif
	-DENABLE_VIDEO=ON \
	-DENABLE_WEB_AUDIO=ON \
	-DENABLE_WEBGL=ON \
	-DPORT=GTK \
	-DSHOULD_INSTALL_JS_SHELL=ON

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%if "%{_gtkdocdir}" != "%{_datadir}/gtk-doc/html"
install -d $RPM_BUILD_ROOT%{_gtkdocdir}
%{__mv} $RPM_BUILD_ROOT%{_datadir}/gtk-doc/html/* $RPM_BUILD_ROOT%{_gtkdocdir}
%endif

%find_lang WebKit2GTK-4.0

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files -f WebKit2GTK-4.0.lang
%defattr(644,root,root,755)
%doc NEWS
%attr(755,root,root) %{_bindir}/WebKitWebDriver
%attr(755,root,root) %{_libdir}/libwebkit2gtk-4.0.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libwebkit2gtk-4.0.so.37
%attr(755,root,root) %{_libdir}/libjavascriptcoregtk-4.0.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjavascriptcoregtk-4.0.so.18
%if %{with introspection}
%{_libdir}/girepository-1.0/JavaScriptCore-4.0.typelib
%{_libdir}/girepository-1.0/WebKit2-4.0.typelib
%{_libdir}/girepository-1.0/WebKit2WebExtension-4.0.typelib
%endif
%dir %{_libexecdir}/webkit2gtk-4.0
%attr(755,root,root) %{_libexecdir}/webkit2gtk-4.0/WebKitNetworkProcess
%attr(755,root,root) %{_libexecdir}/webkit2gtk-4.0/WebKitPluginProcess
%attr(755,root,root) %{_libexecdir}/webkit2gtk-4.0/WebKitPluginProcess2
%attr(755,root,root) %{_libexecdir}/webkit2gtk-4.0/WebKitStorageProcess
%attr(755,root,root) %{_libexecdir}/webkit2gtk-4.0/WebKitWebProcess
%attr(755,root,root) %{_libexecdir}/webkit2gtk-4.0/jsc
%dir %{_libdir}/webkit2gtk-4.0
%dir %{_libdir}/webkit2gtk-4.0/injected-bundle
%attr(755,root,root) %{_libdir}/webkit2gtk-4.0/injected-bundle/libwebkit2gtkinjectedbundle.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libwebkit2gtk-4.0.so
%attr(755,root,root) %{_libdir}/libjavascriptcoregtk-4.0.so
%if %{with introspection}
%{_datadir}/gir-1.0/JavaScriptCore-4.0.gir
%{_datadir}/gir-1.0/WebKit2-4.0.gir
%{_datadir}/gir-1.0/WebKit2WebExtension-4.0.gir
%endif
%{_includedir}/webkitgtk-4.0
%{_pkgconfigdir}/javascriptcoregtk-4.0.pc
%{_pkgconfigdir}/webkit2gtk-4.0.pc
%{_pkgconfigdir}/webkit2gtk-web-extension-4.0.pc

%files apidocs
%defattr(644,root,root,755)
%{_gtkdocdir}/webkit2gtk-4.0
%{_gtkdocdir}/webkitdomgtk-4.0
%changelog
* Wed Jan 10 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gtk-webkit4.git;a=log;h=master

* Wed Jan 10 2018 Marcin Banasiak <marcin.banasiak@gmail.com> acfa648
- Update to 2.18.5 (fixes: CVE-2017-5753 and CVE-2017-5715)

* Mon Jan 01 2018 Jan Rękorajski <baggins@pld-linux.org> 0e4ef76
- release 3 (by relup.sh)

* Mon Jan 01 2018 Marcin Banasiak <marcin.banasiak@gmail.com> 176cc4e
- Add missing dir. Release 2

* Sun Dec 31 2017 Marcin Banasiak <marcin.banasiak@gmail.com> 4ae8fac
- Update to 2.18.4 (security fixes: CVE-2017-13783, CVE-2017-13784,
CVE-2017-13785, CVE-2017-13788, CVE-2017-13791, CVE-2017-13792,
CVE-2017-13793, CVE-2017-13794, CVE-2017-13795, CVE-2017-13796,
CVE-2017-13798, CVE-2017-13802, CVE-2017-13803, CVE-2017-7156,
CVE-2017-7157, CVE-2017-13856, CVE-2017-13866, CVE-2017-13870)

* Tue Sep 12 2017 Marcin Banasiak <marcin.banasiak@gmail.com> 7ef7d1a
- Update to 2.18.0

* Sun Apr 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 6a5b619
- updated gstreamer version

* Sat Apr 22 2017 Jakub Bogusz <qboosh@pld-linux.org> 9a072c0
- added icu59 patch (fixes build with icu >= 59)
- release 2 (rebuild with icu 59 and libwebp 0.6)

* Mon Apr 10 2017 Marcin Banasiak <marcin.banasiak@gmail.com> ab3324f
- Update to 2.16.1

* Tue Mar 21 2017 Marcin Banasiak <marcin.banasiak@gmail.com> 95bafe5
- Update to 2.16.0

* Fri Mar 10 2017 Jan Rękorajski <baggins@pld-linux.org> 78d6b06
- rebuild with icu 58.2
- release 2 (by relup.sh)

* Wed Feb 15 2017 Marcin Banasiak <marcin.banasiak@gmail.com> 256e80a
- Update to 2.14.5 (security fixes: CVE-2017-2365, CVE-2017-2366,
CVE-2017-2373, CVE-2017-2363, CVE-2017-2362, CVE-2017-2350,
CVE-2017-2350, CVE-2017-2354, CVE-2017-2355, CVE-2017-2356,
CVE-2017-2371, CVE-2017-2364, CVE-2017-2369)

* Tue Jan 17 2017 Marcin Banasiak <marcin.banasiak@gmail.com> 694485f
- Update to 2.14.3 (security fixes: CVE-2016-7656, CVE-2016-7635,
CVE-2016-7654, CVE-2016-7639, CVE-2016-7645, CVE-2016-7652,
CVE-2016-7641, CVE-2016-7632, CVE-2016-7599, CVE-2016-7592,
CVE-2016-7589, CVE-2016-7623, CVE-2016-7586)

* Mon Nov 14 2016 Jaroslaw Kruk <kruk.jaroslaw@gmail.com> b37f926
- updated to 2.14.2

* Sat Oct 15 2016 Jakub Bogusz <qboosh@pld-linux.org> 82029cf
- updated to 2.14.1

* Tue Sep 27 2016 Marcin Banasiak <marcin.banasiak@gmail.com> b533711
- Update to 2.14.0

* Mon Aug 29 2016 Jakub Bogusz <qboosh@pld-linux.org> 0fe5cc0
- updated to 2.12.4 (fixes CVE-2016-1856 CVE-2016-1857 CVE-2016-4590 CVE-2016-4591 CVE-2016-4622 CVE-2016-4624)

* Thu May 19 2016 Jakub Bogusz <qboosh@pld-linux.org> 5e4ace1
- updated options and webkit bcond logic
- added cairogl bcond (ENABLE_ACCELERATED_2D_CANVAS, depending on cairo-gl)

* Thu May 19 2016 Jakub Bogusz <qboosh@pld-linux.org> 6514e20
- updated to 2.12.2

* Mon May 16 2016 Elan Ruusamäe <glen@delfi.ee> 64a053c
- icu-57.1 rebuild
- release 2 (by relup.sh)

* Sun Mar 27 2016 Elan Ruusamäe <glen@delfi.ee> 87ac862
- drop unused gnutls-devel

